src/Entity/Question.php
<?php

namespace App\Entity;

use App\Repository\QuestionRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass=QuestionRepository::class)
 */
class Question
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Assert\Length(min="1", minMessage="Ce champs doit contenir au moins un caractère.")
     */
    private $name;

    /**
     * @ORM\OneToMany(targetEntity=Reponse::class, mappedBy="question", cascade={"remove"})
     */
    private $reponses;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="questions")
     */
    private $owner;

    /**
     * @ORM\OneToMany(targetEntity=Vote::class, mappedBy="question_id", orphanRemoval=true)
     */
    private $votes;

    public function __construct()
    {
        //$this->users = new ArrayCollection();
        $this->reponses = new ArrayCollection();
        $this->votes = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }


    /**
     * @return Collection|Reponse[]
     */
    public function getReponses(): Collection
    {
        return $this->reponses;
    }

    public function addReponse(Reponse $reponse): self
    {
        if (!$this->reponses->contains($reponse)) {
            $this->reponses[] = $reponse;
            $reponse->setQuestion($this);
        }

        return $this;
    }

    public function removeReponse(Reponse $reponse): self
    {
        if ($this->reponses->removeElement($reponse)) {
            // set the owning side to null (unless already changed)
            if ($reponse->getQuestion() === $this) {
                $reponse->setQuestion(null);
            }
        }

        return $this;
    }

    public function __toString()
    {
        return $this->name;
    }

    public function getOwner(): ?User
    {
        return $this->owner;
    }

    public function setOwner(?User $owner): self
    {
        $this->owner = $owner;

        return $this;
    }

    /**
     * @return Collection|Vote[]
     */
    public function getVotes(): Collection
    {
        return $this->votes;
    }

    public function addVote(Vote $vote): self
    {
        if (!$this->votes->contains($vote)) {
            $this->votes[] = $vote;
            $vote->setQuestionId($this);
        }

        return $this;
    }

    public function removeVote(Vote $vote): self
    {
        if ($this->votes->removeElement($vote)) {
            // set the owning side to null (unless already changed)
            if ($vote->getQuestionId() === $this) {
                $vote->setQuestionId(null);
            }
        }

        return $this;
    }
}

src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Security\Core\Security;
use Vich\UploaderBundle\Mapping\Annotation as Vich;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @UniqueEntity(fields={"email"}, message="There is already an account with this email")
 * @Vich\Uploadable()
 */
class User implements UserInterface
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=180, unique=true)
     */
    private $email;

    /**
     * @ORM\Column(type="json")
     */
    private $roles = [];

    /**
     * @var string The hashed password
     * @ORM\Column(type="string")
     */
    private $password;


    /**
     * @ORM\Column(type="boolean")
     */
    private $isVerified = false;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $logoFileName;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $updateAt;

    /**
     * @Vich\UploadableField(mapping="products", fileNameProperty="logoFileName")
     */

    private $logoFile;


    /**
     * @ORM\OneToMany(targetEntity=Question::class, mappedBy="owner", cascade={"remove"})
     */
    private $questions;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $nickname;

    public function __construct()
    {
        $this->questions = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUsername(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getPassword(): string
    {
        return (string) $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getSalt()
    {
        // not needed when using the "bcrypt" algorithm in security.yaml
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    public function isVerified(): bool
    {
        return $this->isVerified;
    }

    public function setIsVerified(bool $isVerified): self
    {
        $this->isVerified = $isVerified;

        return $this;
    }

    public function getLogoFileName(): ?string
    {
        return $this->logoFileName;
    }

    public function setLogoFileName(?string $logoFileName): self
    {
        $this->logoFileName = $logoFileName;

        return $this;
    }

    public function getUpdateAt(): ?\DateTimeInterface
    {
        return $this->updateAt;
    }

    public function setUpdateAt(?\DateTimeInterface $updateAt): self
    {
        $this->updateAt = $updateAt;

        return $this;
    }

    public function getLogoFile()
    {
        return $this->logoFile;
    }

    public function setLogoFile($logoFile)
    {
        $this->logoFile = $logoFile;
        //$this->setUpdatedAt(new \DateTime());

        return $this;
    }


    public function __toString()
    {
        return $this->email;
    }

    /**
     * @return Collection|Question[]
     */
    public function getQuestions(): Collection
    {
        return $this->questions;
    }

    public function addQuestion(Question $question): self
    {
        if (!$this->questions->contains($question)) {
            $this->questions[] = $question;
            $question->setUserId($this);
        }

        return $this;
    }

    public function removeQuestion(Question $question): self
    {
        if ($this->questions->removeElement($question)) {
            // set the owning side to null (unless already changed)
            if ($question->getUserId() === $this) {
                $question->setUserId(null);
            }
        }

        return $this;
    }

    public function getNickname(): ?string
    {
        return $this->nickname;
    }

    public function setNickname(?string $nickname): self
    {
        $this->nickname = $nickname;

        return $this;
    }
}

src/Controller/QuestionController.php
<?php

namespace App\Controller;

use App\Entity\Question;
use App\Entity\Reponse;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class QuestionController extends AbstractController
{
    /**
     * @Route("/create", name="create")
     * @param Request $request
     * @return Response
     */
    public function create(Request $request): Response
    {
        $json = json_decode($request ->getContent(), true);


        if (isset($json["question"]) && isset($json["reponses"]))
        {
            $entityManager = $this->getDoctrine()->getManager(); //Pour sauvegarder l'info dans la base de données et l'extraire
            $question = new Question();
            $question->setName($json["question"]);

            $question->setOwner($this->getUser());


            foreach ($json["reponses"] as $value)
            {
                if ($value)
                {
                    $reponse = new Reponse();
                    $reponse->setName($value);
                    $reponse->setQuestion($question);
                    $question->addReponse($reponse);

                    $entityManager->persist($reponse);

                }

                $entityManager->persist($question);
                $entityManager->flush();
            }


            return $this->json([
                "id" => $question->getId()
            ]);
        }
        return new Response("Error", Response::HTTP_INTERNAL_SERVER_ERROR);
    }

    /**
     * @Route("/question_delete/{id}", name="question_delete")
     * @param Request $request
     * @param int $id
     * @return Response
     */
    public function question_delete (Request $request, int $id):Response
    {
        $entityManager = $this->getDoctrine()->getManager(); //je récupère l'entity manager

        //Je récupère le question
        $question = $this->getDoctrine()->getRepository(Question::class)->find($id);
            $entityManager->remove($question);
            $entityManager->flush();

        return $this->json([
            "id" => $question->getId()
        ]);

    }
    /**
     * @Route("/question", name="question")
     */
    public function index(): Response
    {
        return $this->render('question/index.html.twig', [
            'controller_name' => 'QuestionController',
        ]);
    }

}

templates/question/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Question{% endblock %}

{% block body %}

    {# navbar start #}
    <nav class="navbar navbar-expand-lg nav-bar navbar-dark pt-4">
        <a class="text-white" href="{{ path('home') }}"><h5 class="text-uppercase">Sondage<span class="navbar-logo"><br> créateur</span></h5></a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavAltMarkup" aria-controls="navbarNavAltMarkup" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse justify-content-end" id="navbarNavAltMarkup">
            <div class="navbar-nav">
                <a class="nav-link text-white h5" href="{{ path('profil') }}">Mon profil</a>
                <a class="nav-link text-white h5" href="{{ path('app_logout') }}">Se déconnecter</a>
                <a class="nav-link text-white h5" href="{{ path('home') }}">Accueil</a>
            </div>
        </div>
    </nav>
    {# navbar end #}

    {% if app.user.verified == true %} {# L'utilisateur, qui n'est pas confirmé son e-mail,
     ne peut pas créer un sondage #}

    <div class="wrapper">
    <div class="container w-50">
    <form id="form" class="container">
        <div class="form-group">
            <h2 class="text-white text-center">Créer un sondage</h2>
            <label class="text-white">Question</label>
            <input id="question" class="form-control">
        </div>

        <div id="liste-reponse" class="form-group">
            <label class="text-white">Réponse</label>
            <input data-id="0" data-reponse class="form-control mb-3">
            <input data-id="1" data-reponse class="form-control mt-3 mb-3">
            <input data-id="2" data-reponse class="form-control mt-3 mb-3">
        </div>

    <div class="text-center">
        <button type="submit" class="btn-sondage">Submit</button>
    </div>
    </form>
    </div>
    </div>

    {% else %}
        <div class="d-flex justify-content-center container">
        <p class="text-center h2" style="color: #f4c613">Pour créer votre premier sondage, confirmez votre e-mail ! </p>
        </div>

    {% endif %}

{% endblock %}

{% block javascripts %}
    <script>
        const form = document.getElementById("form");
        const question = document.getElementById("question");
        const inputs = Array.from(document.querySelectorAll("input[data-reponse]"));
        const inputValuesSave = new Array(3).fill("");
        const listeReponse = document.getElementById("liste-reponse");

        function checkInputs (input) { //la fonction checkInputs sera appelée sur chaque input
            const index = input.getAttribute("data-id"); //je récupère l'index
            inputValuesSave[index] = input.value; //je regarde la valeur sauverardée de l'input. si c'est l'input 0, on fait l'inputValuesSave 0, et on met qu'elle est égale à sa valeur
            if (inputValuesSave.every(i => i.length > 0)) {  //Avec every, je regarde, si la valeur de l'input est supérieur à 0. Si la valeur de tous les inputs est sepérieurs à 0, ça veut dire que le tableau est plein.
                const newInput = document.createElement("input"); //Si le tableau est plein, je crée un nouvel input
                newInput.classList.add("form-control", "mt-3", "mb-3"); //Je donne des classes au nouvel input.
                newInput.setAttribute("data-reponse", ""); //Je donne data-reponse au nouvel input
                newInput.setAttribute("data-id", inputValuesSave.length); //Je donne l'id au nouvel input
                newInput.addEventListener("input", checkInputs.bind(null, newInput)); //Je donne au nouvel input à nouveau la fonction checkInputs. Le code continue sur un nouvel input.
                listeReponse.appendChild(newInput); //J'ajoute un nouvel input à listReponse
                inputs.push(newInput); //Je l'ajoute à la fin du tableau
                inputValuesSave.push(""); //La valeur du nouvel input est vide
            }
        }

        inputs.forEach(function (input) {
            input.addEventListener("input", checkInputs.bind(null, input));
        });

        form.addEventListener("submit", function (e){
                e.preventDefault();
                //console.log("test");
                fetch("/create", {
                    method: "POST",
                    body: JSON.stringify({
                        question: question.value,
                        reponses: Array.from(inputs).map(i => i.value)
                    })
                }).then(function (res) {
                    return res.json();
                }).then(function (json){
                    window.location = "/vote/" + json.id
                });
            });
    </script>
{% endblock %}

{% block stylesheets %}
    <style>
        body {
            margin: 0;
            padding: 0;
            font-family: Tahoma, serif;
            background-image: url( {{ asset('asset/photo/black.jpg') }} );
            -webkit-background-size: cover;
            background-size: cover;
            height: 100vh;
        }

        .wrapper {
            display: flex;
            height: 80vh;
            justify-content: center;
            align-items: center;
        }

        .navbar-logo {
            color: #f4c613;
        }
        .navbar-logo a {
            cursor: pointer;
        }

        .navbar-logo a:hover {
            text-decoration: none;
        }

        .btn-sondage {
            border-radius: 28px;
            font-size: 13px;
            text-transform: uppercase;
            margin: 0 6px;
            padding: 12px 46px 12px 46px;
            transition: all 0.4s;
            background-color: #f4c613;
            color: white;
        }

    </style>
{% endblock %}